<template>
  <div>
    <el-card class="el-card">
      <el-form :model="listQuery" label-width="120px" v-if="showSearch">
        <el-row>
          <el-col :span="18">
            <el-form-item label="UDI码:">
              <el-input v-model="listQuery.udiCode" style="width: 96%" placeholder="请扫描或输入UDI码" clearable="true"
                        @keyup.enter.native="keyup_submit($event)"></el-input>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="6">
            <el-form-item label="拼音简写:">
              <el-input v-model="listQuery.pinyinInitial" @input="search" style="width: 100%" placeholder="请输入物资拼音简写"
                        clearable="true"></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="6">
            <el-form-item label="第三方物资编码:">
              <el-input v-model="listQuery.thrPiId" style="width: 100%" placeholder="第三方物资编码"
                        clearable="true"></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="6">
            <el-form-item label="分类编码:">
              <el-input v-model="listQuery.flbm" style="width: 100%" placeholder="请输入分类编码"
                        clearable="true"></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="6">
            <el-form-item label="供应商:">
              <el-input v-model="listQuery.companyName" style="width: 100%" placeholder="请输入供应商"
                        clearable="true"></el-input>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="6">
            <el-form-item label="物品编码:">
              <el-input v-model="listQuery.unionCode" style="width: 100%" placeholder="请输入DI/医保编码/商品条码"
                        clearable="true"></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="6">
            <el-form-item label="产品通用名:">
              <el-input v-model="listQuery.cpmctymc" style="width: 100%" placeholder="请输入产品通用名"
                        clearable="true"></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="6">
            <el-form-item label="规格型号:">
              <el-input v-model="listQuery.ggxh" style="width: 100%" placeholder="请输入规格型号" clearable="true"></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="6">
            <el-form-item label="生产企业:">
              <el-input v-model="listQuery.manufactory" style="width: 100%" placeholder="请输入生产企业/注册备案人"
                        clearable="true"></el-input>
            </el-form-item>
          </el-col>
        </el-row>

        <el-row>
          <el-col :span="6">
            <el-form-item label="物资分类:">
              <el-input v-model="listQuery.category" style="width: 100%" placeholder="请输入物资分类名称"
                        clearable="true"></el-input>
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>


      <div class="top-right-btn">
        <el-button-group style="display:flex;">
          <el-button icon="el-icon-view" type="primary" @click="hideSearch">显示/隐藏搜索栏</el-button>
          <el-button type="primary" icon="el-icon-refresh" @click="onReset">重置</el-button>
          <el-button type="primary" icon="el-icon-search" @click="search">查询</el-button>
          <el-button type="primary" icon="el-icon-plus" @click="confirmSelect" :loading="confirmLoading">确定</el-button>
        </el-button-group>
      </div>
      <el-divider style="margin: 15px"></el-divider>

      <el-table :data="dataList" style="width: 100%" v-loading="loading" border highlight-current-row
                @selection-change="handleSelectionChange" ref="multipleTable">
        <el-table-column type="selection" :reserve-selection="true"></el-table-column>
        <el-table-column label="序号" type="index"></el-table-column>
        <el-table-column label="最小销售产品标识" prop="nameCode" width="140" show-overflow-tooltip></el-table-column>
        <el-table-column label="第三方物资编码" prop="thirdId" show-overflow-tooltip></el-table-column>
        <el-table-column label="医疗器械注册人" prop="ylqxzcrbarmc"></el-table-column>
        <el-table-column label="物资名称" prop="cpmctymc" show-overflow-tooltip></el-table-column>
        <el-table-column label="规格型号" prop="ggxh" show-overflow-tooltip></el-table-column>
        <el-table-column label="注册/备案凭证" prop="zczbhhzbapzbh" show-overflow-tooltip></el-table-column>
        <el-table-column label="器械类别" prop="qxlb" show-overflow-tooltip></el-table-column>
        <el-table-column label="供应商" prop="companyName" show-overflow-tooltip></el-table-column>
      </el-table>

      <pagination
          v-show="pageTotal>0"
          :total="pageTotal"
          :page.sync="listQuery.page"
          :limit.sync="listQuery.limit"
          @pagination="handleErpPageChange"

      ></pagination>
    </el-card>
  </div>
</template>

<script>
import {filterCompanyProductplanRelevance, filterCompanyProductRelevance} from "../../../api/basic/udiRlSuptRelevance";
import {addApplyDetail, addApply} from "../../../api/purchase/purApply";
import store from "../../../store";
import udiRlDetailDialog from "./../../purchase/purApply/purUdiRlDetailDialog";
import {finProductSet} from "@/api/param/systemParamConfig";
import {addModeldestinyProduct, filterDestinyDelect, filterDestinyProduct} from "@/api/basic/basicDestinyRel";

export default {
  name: "stockOrderNewSelectProduct",
  props: {
    closeDialog: {
      type: Function,
      required: true,
    },
    editQuery: {
      type: Object,
      required: true,
    },
    codeArray: {
      type: Object,
      required: true,
    },
  },

  data() {
    return {
      showSearch: true,
      listQuery: {
        purType: null,
        udiCode: null,
        unicode: null,
        cpmctymc: null,
        ggxh: null,
        ylqxzcrbarmc: null,
        thrPiId: null,
        pinyinInitial: null,
        page: 1,
        limit: 10,
      },
      combineQuery: {
        thirdId: "",
        relId: "",
        erpName: "",
        keys: [],
      },
      ids: [],
      lists: [],
      radioCheck: null,
      dataList: [],
      pageTotal: 1,
      total: 1,
      currentRow: null,
      loading: false,
      udiRlDetailVisible: false,
      thirdSys: [],
      thirdSysFk: null,
      busTypes: [],
      actDateRange: [],
      tQuery: {
        productId: "",
        productName: "",
        count: "",
        orderIdFk: "",
        supId: "",
      },
      productRemarkSet: {},
      pickerOptions: {
        shortcuts: [
          {
            text: "最近一周",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 7);
              picker.$emit("pick", [start, end]);
            },
          },
          {
            text: "最近一个月",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 30);
              picker.$emit("pick", [start, end]);
            },
          },
          {
            text: "最近三个月",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 90);
              picker.$emit("pick", [start, end]);
            },
          },
        ],
      },
      orderEditor: false,
      orderId: "",
      currentCert: null,
      certList: [],
      dialogFormVisible: false,
      multipleSelection: null,
    };
  },
  methods: {
    onReset() {
      this.$router.push({
        path: "",
      });
      this.listQuery = {
        purType: null,
        udiCode: null,
        unicode: null,
        cpmctymc: null,
        ggxh: null,
        ylqxzcrbarmc: null,
        thrPiId: null,
        page: 1,
        limit: 10
      }
      this.multipleSelection = [];
      this.radioCheck = null;
      this.currentRow = null;
      this.getList();
    },
    hideSearch() {
      this.showSearch = !this.showSearch;
    },
    handleCurrentChange(val) {
      this.unionQuery.page = val;
      this.getList();
    },
    handleChange(val) {
      this.radioCheck = val.id;
      this.currentRow = val;
      this.multipleSelection = val
    },
    handleDetailClick(row) {
      this.currentRow = row;
      this.udiRlDetailVisible = true;

    },
    handleErpPageChange(val) {
      this.listQuery.page = val.page;
      this.getList();
    },
    keyup_submit(event) {
      this.listQuery.page = 1;
      this.getList();
      event.target.select();
    },
    search() {
      this.listQuery.page = 1;
      this.getList();
    },
    handleSelectionChange(val) {
      this.lists = [];
      for (var i = 0; i < val.length; i++) {
        let data = {
          udiRlIdFk: val[i].id,
          unitFk: val[i].unitFk
        }
        this.lists.push(data)
      }
    },
    getList() {
      this.loading = true;
      this.listQuery.id = this.editQuery.id
      filterDestinyProduct(this.listQuery)
          .then((response) => {
            this.loading = false;
            if (response.code === 20000) {
              this.dataList = response.data.list || [];
              this.pageTotal = response.data.total || 0;
            } else {
              this.$message.error(response.message);
              this.dataList = [];
              this.pageTotal = 0;
            }
          })
          .catch(() => {
            this.loading = false;
            this.dataList = [];
            this.pageTotal = 0;
          });
    },
    confirmSelect() {
      if (this.lists == null) {
        this.$message.error('未选择产品');
        return;
      }
      this.combine();
    },
    combine() {
      this.confirmLoading = true;
      addModeldestinyProduct({pId: this.editQuery.id, list: this.lists}).then((response) => {
        this.confirmLoading = false;
        if (response.code === 20000) {
          this.closeDialog(response.data);
        } else {
          this.$message.error(response.message);
        }
      }).catch(() => {
        this.confirmLoading = false;
      });
    },
  },
  components: {udiRlDetailDialog},

  created() {
    this.getList();
  },
};
</script>

<style scoped>

div /deep/ .el-table .warning-row {
  background: #bebebe;
}

div /deep/ .el-table .success-row {
  background: #ffffff;
}
</style>
